package com.sun.corba.se.impl.encoding;

import com.sun.org.omg.SendingContext.CodeBase;
import com.sun.corba.se.spi.ior.iiop.GIOPVersion;
import org.omg.CORBA.DoubleSeqHolder;
import org.omg.CORBA.FloatSeqHolder;
import org.omg.CORBA.LongLongSeqHolder;
import org.omg.CORBA.ULongLongSeqHolder;
import org.omg.CORBA.ULongSeqHolder;
import org.omg.CORBA.LongSeqHolder;
import org.omg.CORBA.UShortSeqHolder;
import org.omg.CORBA.ShortSeqHolder;
import org.omg.CORBA.OctetSeqHolder;
import org.omg.CORBA.WCharSeqHolder;
import org.omg.CORBA.CharSeqHolder;
import org.omg.CORBA.BooleanSeqHolder;
import org.omg.CORBA.AnySeqHolder;
import org.omg.CORBA.portable.BoxedValueHelper;
import java.io.Serializable;
import org.omg.CORBA.Context;
import java.math.BigDecimal;
import java.io.IOException;
import org.omg.CORBA.NO_IMPLEMENT;
import org.omg.CORBA.Principal;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.Object;
import java.nio.ByteBuffer;
import org.omg.CORBA.ORB;
import java.io.InputStream;

abstract class CDRInputStreamBase extends InputStream
{
    protected CDRInputStream parent;
    
    CDRInputStreamBase() {
    }
    
    public void setParent(CDRInputStream parent) {
        this.parent = parent;
    }
    
    public abstract void init(ORB p0, ByteBuffer p1, int p2, boolean p3, BufferManagerRead p4);
    
    public abstract boolean read_boolean();
    
    public abstract char read_char();
    
    public abstract char read_wchar();
    
    public abstract byte read_octet();
    
    public abstract short read_short();
    
    public abstract short read_ushort();
    
    public abstract int read_long();
    
    public abstract int read_ulong();
    
    public abstract long read_longlong();
    
    public abstract long read_ulonglong();
    
    public abstract float read_float();
    
    public abstract double read_double();
    
    public abstract String read_string();
    
    public abstract String read_wstring();
    
    public abstract void read_boolean_array(boolean[] p0, int p1, int p2);
    
    public abstract void read_char_array(char[] p0, int p1, int p2);
    
    public abstract void read_wchar_array(char[] p0, int p1, int p2);
    
    public abstract void read_octet_array(byte[] p0, int p1, int p2);
    
    public abstract void read_short_array(short[] p0, int p1, int p2);
    
    public abstract void read_ushort_array(short[] p0, int p1, int p2);
    
    public abstract void read_long_array(int[] p0, int p1, int p2);
    
    public abstract void read_ulong_array(int[] p0, int p1, int p2);
    
    public abstract void read_longlong_array(long[] p0, int p1, int p2);
    
    public abstract void read_ulonglong_array(long[] p0, int p1, int p2);
    
    public abstract void read_float_array(float[] p0, int p1, int p2);
    
    public abstract void read_double_array(double[] p0, int p1, int p2);
    
    public abstract org.omg.CORBA.Object read_Object();
    
    public abstract TypeCode read_TypeCode();
    
    public abstract Any read_any();
    
    public abstract Principal read_Principal();
    
    @Override
    public int read() throws IOException {
        throw new NO_IMPLEMENT();
    }
    
    public abstract BigDecimal read_fixed();
    
    public Context read_Context() {
        throw new NO_IMPLEMENT();
    }
    
    public abstract org.omg.CORBA.Object read_Object(Class p0);
    
    public abstract ORB orb();
    
    public abstract Serializable read_value();
    
    public abstract Serializable read_value(Class p0);
    
    public abstract Serializable read_value(BoxedValueHelper p0);
    
    public abstract Serializable read_value(String p0);
    
    public abstract Serializable read_value(Serializable p0);
    
    public abstract Object read_abstract_interface();
    
    public abstract Object read_abstract_interface(Class p0);
    
    public abstract void consumeEndian();
    
    public abstract int getPosition();
    
    public abstract Object read_Abstract();
    
    public abstract Serializable read_Value();
    
    public abstract void read_any_array(AnySeqHolder p0, int p1, int p2);
    
    public abstract void read_boolean_array(BooleanSeqHolder p0, int p1, int p2);
    
    public abstract void read_char_array(CharSeqHolder p0, int p1, int p2);
    
    public abstract void read_wchar_array(WCharSeqHolder p0, int p1, int p2);
    
    public abstract void read_octet_array(OctetSeqHolder p0, int p1, int p2);
    
    public abstract void read_short_array(ShortSeqHolder p0, int p1, int p2);
    
    public abstract void read_ushort_array(UShortSeqHolder p0, int p1, int p2);
    
    public abstract void read_long_array(LongSeqHolder p0, int p1, int p2);
    
    public abstract void read_ulong_array(ULongSeqHolder p0, int p1, int p2);
    
    public abstract void read_ulonglong_array(ULongLongSeqHolder p0, int p1, int p2);
    
    public abstract void read_longlong_array(LongLongSeqHolder p0, int p1, int p2);
    
    public abstract void read_float_array(FloatSeqHolder p0, int p1, int p2);
    
    public abstract void read_double_array(DoubleSeqHolder p0, int p1, int p2);
    
    public abstract String[] _truncatable_ids();
    
    @Override
    public abstract void mark(int p0);
    
    @Override
    public abstract void reset();
    
    @Override
    public boolean markSupported() {
        return false;
    }
    
    public abstract CDRInputStreamBase dup();
    
    public abstract BigDecimal read_fixed(short p0, short p1);
    
    public abstract boolean isLittleEndian();
    
    abstract void setHeaderPadding(boolean p0);
    
    public abstract ByteBuffer getByteBuffer();
    
    public abstract void setByteBuffer(ByteBuffer p0);
    
    public abstract void setByteBufferWithInfo(ByteBufferWithInfo p0);
    
    public abstract int getBufferLength();
    
    public abstract void setBufferLength(int p0);
    
    public abstract int getIndex();
    
    public abstract void setIndex(int p0);
    
    public abstract void orb(ORB p0);
    
    public abstract BufferManagerRead getBufferManager();
    
    public abstract GIOPVersion getGIOPVersion();
    
    abstract CodeBase getCodeBase();
    
    abstract void printBuffer();
    
    abstract void alignOnBoundary(int p0);
    
    abstract void performORBVersionSpecificInit();
    
    public abstract void resetCodeSetConverters();
    
    public abstract void start_value();
    
    public abstract void end_value();
}
